clear *,close all;clc;
%
%  Read the two letter boundaries from file letters.dat
%
fid = fopen('letters.dat');
gamma=zeros(2,64);ci=zeros(2,64);%set zero the arrays
[gamma,count]=fscanf(fid,'%d %d',[2, 53]);
% read ci boundary
[ci,count]=fscanf(fid,'%d %d',[2, 64]);
fclose(fid);
% Add eleven more points to the boundary of gamma {gamma(1:2,54:64} so that it
% has the same number of points with that of ci, equal to a power of two.
gamma(:,54:64)=gamma(:,1:11);
%plot the two letters as they are in the intial form
plot(gamma(1,:)',gamma(2,:)','o',ci(1,:)',ci(2,:)','o')
title ('Initial Scheme of the Two Letters')
%
% Construction of the Letters Through a Small Part of the fft Coefficients  
%
% fft evaluation for gamma & zeroing the first coefficient
gamma_complex=gamma(1,:)'+i*gamma(2,:)';
ff_gamma=fft(gamma_complex);
ff_gamma(1)=0;
% fft evaluation for ci & zeroing the first coefficient
ci_complex=ci(1,:)'+j*ci(2,:)';
ff_ci=fft(ci_complex);
ff_ci(1)=0;
% First construct and plot letters through 2&2 coefficients
constr_letter(ff_gamma,ff_ci,2,'2&2 DFT Coefficients');
% First construct and plot letters through 10&10 coefficients
constr_letter(ff_gamma,ff_ci,10,'10&10 DFT Coefficients');
% Finaly use all the coefficients to construct the letters
gamma_complex_scr=ifft(ff_gamma);
ci_complex_scr=ifft(ff_ci);
figure;
plot(real(gamma_complex_scr),imag(gamma_complex_scr),'o',...
    real(ci_complex_scr)+14,imag(ci_complex_scr),'o')
title('All DFT Coefficients')
%
% Evaluate and plot the 63 coefficients
%
figure;
stem(abs(ff_gamma(2:64)))
title('DFT Coefficients measures for gamma')
figure;
stem(abs(ff_ci(2:64)))
title('DFT Coefficients measures for ci')
%  Shift  letter sequence 
gamma_complex_n=gamma_complex+15+10i;ci_complex_n=ci_complex+20+10i;
% Rotate letter sequence (i.e. change starting point of sampling)
scr=gamma_complex_n(1:9);gamma_complex_n=gamma_complex_n(10:64);gamma_complex_n(56:64)=scr;
scr=ci_complex_n(1:14);ci_complex_n=ci_complex_n(15:64);ci_complex_n(51:64)=scr;
gamma_complex_n =real(gamma_complex_n)*cos(pi/4)+i*imag(gamma_complex_n)*cos(pi/4);
ci_complex_n =real(ci_complex_n)*cos(pi/3)+i*imag(ci_complex_n)*cos(pi/3);
ff_gamma_n=fft(gamma_complex_n);ff_ci_n=fft(ci_complex_n);
figure;
subplot(1,2,1)
stem(abs(ff_gamma_n(2:64))/abs(ff_gamma_n(2)))
title('DFT Coeff. meas.  for gamma after shift, e.t.c. ')
subplot(1,2,2)
stem(abs(ff_gamma(2:64))/abs(ff_gamma(2)))
title('DFT Coeff. meas.  for gamma ')

figure;
subplot(1,2,1)
stem(abs(ff_ci_n(2:64)/abs(ff_ci_n(2))))
title('DFT Coeff. meas. for ci after shift, e.t.c. ')
subplot(1,2,2)
stem(abs(ff_ci(2:64)/abs(ff_ci_n(2))))
title('DFT Coeff. meas. for ci  ')

